<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Yetki ServiceType
 * @subpackage Services
 */
class Yetki extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named yetkiBelgesiKontrol
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\YetkiBelgesiKontrol $parameters
     * @return \StructType\YetkiBelgesiKontrolResponse|bool
     */
    public function yetkiBelgesiKontrol(\StructType\YetkiBelgesiKontrol $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->yetkiBelgesiKontrol($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\YetkiBelgesiKontrolResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
