<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for uetdsEsyaParamEsyaTurSonuc StructType
 * @subpackage Structs
 */
class UetdsEsyaParamEsyaTurSonuc extends AbstractStructBase
{
    /**
     * The sonucKodu
     * @var int
     */
    public $sonucKodu;
    /**
     * The sonucMesaji
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sonucMesaji;
    /**
     * The yukTurListesi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ParamEsyaTurListesi[]
     */
    public $yukTurListesi;
    /**
     * Constructor method for uetdsEsyaParamEsyaTurSonuc
     * @uses UetdsEsyaParamEsyaTurSonuc::setSonucKodu()
     * @uses UetdsEsyaParamEsyaTurSonuc::setSonucMesaji()
     * @uses UetdsEsyaParamEsyaTurSonuc::setYukTurListesi()
     * @param int $sonucKodu
     * @param string $sonucMesaji
     * @param \StructType\ParamEsyaTurListesi[] $yukTurListesi
     */
    public function __construct($sonucKodu = null, $sonucMesaji = null, array $yukTurListesi = array())
    {
        $this
            ->setSonucKodu($sonucKodu)
            ->setSonucMesaji($sonucMesaji)
            ->setYukTurListesi($yukTurListesi);
    }
    /**
     * Get sonucKodu value
     * @return int|null
     */
    public function getSonucKodu()
    {
        return $this->sonucKodu;
    }
    /**
     * Set sonucKodu value
     * @param int $sonucKodu
     * @return \StructType\UetdsEsyaParamEsyaTurSonuc
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        $this->sonucKodu = $sonucKodu;
        return $this;
    }
    /**
     * Get sonucMesaji value
     * @return string|null
     */
    public function getSonucMesaji()
    {
        return $this->sonucMesaji;
    }
    /**
     * Set sonucMesaji value
     * @param string $sonucMesaji
     * @return \StructType\UetdsEsyaParamEsyaTurSonuc
     */
    public function setSonucMesaji($sonucMesaji = null)
    {
        // validation for constraint: string
        if (!is_null($sonucMesaji) && !is_string($sonucMesaji)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucMesaji, true), gettype($sonucMesaji)), __LINE__);
        }
        $this->sonucMesaji = $sonucMesaji;
        return $this;
    }
    /**
     * Get yukTurListesi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ParamEsyaTurListesi[]|null
     */
    public function getYukTurListesi()
    {
        return isset($this->yukTurListesi) ? $this->yukTurListesi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setYukTurListesi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setYukTurListesi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateYukTurListesiForArrayConstraintsFromSetYukTurListesi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $uetdsEsyaParamEsyaTurSonucYukTurListesiItem) {
            // validation for constraint: itemType
            if (!$uetdsEsyaParamEsyaTurSonucYukTurListesiItem instanceof \StructType\ParamEsyaTurListesi) {
                $invalidValues[] = is_object($uetdsEsyaParamEsyaTurSonucYukTurListesiItem) ? get_class($uetdsEsyaParamEsyaTurSonucYukTurListesiItem) : sprintf('%s(%s)', gettype($uetdsEsyaParamEsyaTurSonucYukTurListesiItem), var_export($uetdsEsyaParamEsyaTurSonucYukTurListesiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The yukTurListesi property can only contain items of type \StructType\ParamEsyaTurListesi, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set yukTurListesi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ParamEsyaTurListesi[] $yukTurListesi
     * @return \StructType\UetdsEsyaParamEsyaTurSonuc
     */
    public function setYukTurListesi(array $yukTurListesi = array())
    {
        // validation for constraint: array
        if ('' !== ($yukTurListesiArrayErrorMessage = self::validateYukTurListesiForArrayConstraintsFromSetYukTurListesi($yukTurListesi))) {
            throw new \InvalidArgumentException($yukTurListesiArrayErrorMessage, __LINE__);
        }
        if (is_null($yukTurListesi) || (is_array($yukTurListesi) && empty($yukTurListesi))) {
            unset($this->yukTurListesi);
        } else {
            $this->yukTurListesi = $yukTurListesi;
        }
        return $this;
    }
    /**
     * Add item to yukTurListesi value
     * @throws \InvalidArgumentException
     * @param \StructType\ParamEsyaTurListesi $item
     * @return \StructType\UetdsEsyaParamEsyaTurSonuc
     */
    public function addToYukTurListesi(\StructType\ParamEsyaTurListesi $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParamEsyaTurListesi) {
            throw new \InvalidArgumentException(sprintf('The yukTurListesi property can only contain items of type \StructType\ParamEsyaTurListesi, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->yukTurListesi[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UetdsEsyaParamEsyaTurSonuc
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
