<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for uetdsEsyaWsBildirimListesiSonuc StructType
 * @subpackage Structs
 */
class UetdsEsyaWsBildirimListesiSonuc extends AbstractStructBase
{
    /**
     * The sonucKodu
     * @var int
     */
    public $sonucKodu;
    /**
     * The sonucMesaji
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sonucMesaji;
    /**
     * The bildirimListesi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WsYukBildirimiListesi[]
     */
    public $bildirimListesi;
    /**
     * Constructor method for uetdsEsyaWsBildirimListesiSonuc
     * @uses UetdsEsyaWsBildirimListesiSonuc::setSonucKodu()
     * @uses UetdsEsyaWsBildirimListesiSonuc::setSonucMesaji()
     * @uses UetdsEsyaWsBildirimListesiSonuc::setBildirimListesi()
     * @param int $sonucKodu
     * @param string $sonucMesaji
     * @param \StructType\WsYukBildirimiListesi[] $bildirimListesi
     */
    public function __construct($sonucKodu = null, $sonucMesaji = null, array $bildirimListesi = array())
    {
        $this
            ->setSonucKodu($sonucKodu)
            ->setSonucMesaji($sonucMesaji)
            ->setBildirimListesi($bildirimListesi);
    }
    /**
     * Get sonucKodu value
     * @return int|null
     */
    public function getSonucKodu()
    {
        return $this->sonucKodu;
    }
    /**
     * Set sonucKodu value
     * @param int $sonucKodu
     * @return \StructType\UetdsEsyaWsBildirimListesiSonuc
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        $this->sonucKodu = $sonucKodu;
        return $this;
    }
    /**
     * Get sonucMesaji value
     * @return string|null
     */
    public function getSonucMesaji()
    {
        return $this->sonucMesaji;
    }
    /**
     * Set sonucMesaji value
     * @param string $sonucMesaji
     * @return \StructType\UetdsEsyaWsBildirimListesiSonuc
     */
    public function setSonucMesaji($sonucMesaji = null)
    {
        // validation for constraint: string
        if (!is_null($sonucMesaji) && !is_string($sonucMesaji)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucMesaji, true), gettype($sonucMesaji)), __LINE__);
        }
        $this->sonucMesaji = $sonucMesaji;
        return $this;
    }
    /**
     * Get bildirimListesi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WsYukBildirimiListesi[]|null
     */
    public function getBildirimListesi()
    {
        return isset($this->bildirimListesi) ? $this->bildirimListesi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBildirimListesi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBildirimListesi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBildirimListesiForArrayConstraintsFromSetBildirimListesi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $uetdsEsyaWsBildirimListesiSonucBildirimListesiItem) {
            // validation for constraint: itemType
            if (!$uetdsEsyaWsBildirimListesiSonucBildirimListesiItem instanceof \StructType\WsYukBildirimiListesi) {
                $invalidValues[] = is_object($uetdsEsyaWsBildirimListesiSonucBildirimListesiItem) ? get_class($uetdsEsyaWsBildirimListesiSonucBildirimListesiItem) : sprintf('%s(%s)', gettype($uetdsEsyaWsBildirimListesiSonucBildirimListesiItem), var_export($uetdsEsyaWsBildirimListesiSonucBildirimListesiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bildirimListesi property can only contain items of type \StructType\WsYukBildirimiListesi, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bildirimListesi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WsYukBildirimiListesi[] $bildirimListesi
     * @return \StructType\UetdsEsyaWsBildirimListesiSonuc
     */
    public function setBildirimListesi(array $bildirimListesi = array())
    {
        // validation for constraint: array
        if ('' !== ($bildirimListesiArrayErrorMessage = self::validateBildirimListesiForArrayConstraintsFromSetBildirimListesi($bildirimListesi))) {
            throw new \InvalidArgumentException($bildirimListesiArrayErrorMessage, __LINE__);
        }
        if (is_null($bildirimListesi) || (is_array($bildirimListesi) && empty($bildirimListesi))) {
            unset($this->bildirimListesi);
        } else {
            $this->bildirimListesi = $bildirimListesi;
        }
        return $this;
    }
    /**
     * Add item to bildirimListesi value
     * @throws \InvalidArgumentException
     * @param \StructType\WsYukBildirimiListesi $item
     * @return \StructType\UetdsEsyaWsBildirimListesiSonuc
     */
    public function addToBildirimListesi(\StructType\WsYukBildirimiListesi $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsYukBildirimiListesi) {
            throw new \InvalidArgumentException(sprintf('The bildirimListesi property can only contain items of type \StructType\WsYukBildirimiListesi, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->bildirimListesi[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UetdsEsyaWsBildirimListesiSonuc
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
