<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for uetdsMesSorguSonuc StructType
 * @subpackage Structs
 */
class UetdsMesSorguSonuc extends AbstractStructBase
{
    /**
     * The belgeListesi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $belgeListesi;
    /**
     * The sonucKodu
     * @var int
     */
    public $sonucKodu;
    /**
     * The sonucMesaji
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sonucMesaji;
    /**
     * Constructor method for uetdsMesSorguSonuc
     * @uses UetdsMesSorguSonuc::setBelgeListesi()
     * @uses UetdsMesSorguSonuc::setSonucKodu()
     * @uses UetdsMesSorguSonuc::setSonucMesaji()
     * @param string[] $belgeListesi
     * @param int $sonucKodu
     * @param string $sonucMesaji
     */
    public function __construct(array $belgeListesi = array(), $sonucKodu = null, $sonucMesaji = null)
    {
        $this
            ->setBelgeListesi($belgeListesi)
            ->setSonucKodu($sonucKodu)
            ->setSonucMesaji($sonucMesaji);
    }
    /**
     * Get belgeListesi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getBelgeListesi()
    {
        return isset($this->belgeListesi) ? $this->belgeListesi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBelgeListesi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBelgeListesi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBelgeListesiForArrayConstraintsFromSetBelgeListesi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $uetdsMesSorguSonucBelgeListesiItem) {
            // validation for constraint: itemType
            if (!is_string($uetdsMesSorguSonucBelgeListesiItem)) {
                $invalidValues[] = is_object($uetdsMesSorguSonucBelgeListesiItem) ? get_class($uetdsMesSorguSonucBelgeListesiItem) : sprintf('%s(%s)', gettype($uetdsMesSorguSonucBelgeListesiItem), var_export($uetdsMesSorguSonucBelgeListesiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The belgeListesi property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set belgeListesi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $belgeListesi
     * @return \StructType\UetdsMesSorguSonuc
     */
    public function setBelgeListesi(array $belgeListesi = array())
    {
        // validation for constraint: array
        if ('' !== ($belgeListesiArrayErrorMessage = self::validateBelgeListesiForArrayConstraintsFromSetBelgeListesi($belgeListesi))) {
            throw new \InvalidArgumentException($belgeListesiArrayErrorMessage, __LINE__);
        }
        if (is_null($belgeListesi) || (is_array($belgeListesi) && empty($belgeListesi))) {
            unset($this->belgeListesi);
        } else {
            $this->belgeListesi = $belgeListesi;
        }
        return $this;
    }
    /**
     * Add item to belgeListesi value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\UetdsMesSorguSonuc
     */
    public function addToBelgeListesi($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The belgeListesi property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->belgeListesi[] = $item;
        return $this;
    }
    /**
     * Get sonucKodu value
     * @return int|null
     */
    public function getSonucKodu()
    {
        return $this->sonucKodu;
    }
    /**
     * Set sonucKodu value
     * @param int $sonucKodu
     * @return \StructType\UetdsMesSorguSonuc
     */
    public function setSonucKodu($sonucKodu = null)
    {
        // validation for constraint: int
        if (!is_null($sonucKodu) && !(is_int($sonucKodu) || ctype_digit($sonucKodu))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sonucKodu, true), gettype($sonucKodu)), __LINE__);
        }
        $this->sonucKodu = $sonucKodu;
        return $this;
    }
    /**
     * Get sonucMesaji value
     * @return string|null
     */
    public function getSonucMesaji()
    {
        return $this->sonucMesaji;
    }
    /**
     * Set sonucMesaji value
     * @param string $sonucMesaji
     * @return \StructType\UetdsMesSorguSonuc
     */
    public function setSonucMesaji($sonucMesaji = null)
    {
        // validation for constraint: string
        if (!is_null($sonucMesaji) && !is_string($sonucMesaji)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sonucMesaji, true), gettype($sonucMesaji)), __LINE__);
        }
        $this->sonucMesaji = $sonucMesaji;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UetdsMesSorguSonuc
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
